--
-- Status column with click handlers
--
-- Source: https://github.com/luukvbaal/statuscol.nvim
-- ..............................................
--
-- Author: Sven Vogel
-- Created: 07.11.2024
-- Edited: 07.11.2024
--
-- ==============================================

return {
    {
        'luukvbaal/statuscol.nvim',
        lazy = true,
        event = {
            "BufEnter",
            "LspAttach"
        },
        config = function()
            local builtin = require("statuscol.builtin")
            require("statuscol").setup({
                setopt = true,
                ft_ignore = {
                    "neo-tree"
                },
                segments = {
                    -- diagnostic signs
                    {
                        sign = {
                            name = { "Diagnostic" },
                            colwidth = 2,
                            maxwidth = 1,
                            condition = { true }
                        },
                        click = "v:lua.ScSa"
                    },
                    -- line numbers
                    {
                        text = { builtin.lnumfunc, " " },
                        click = "v:lua.ScLa",
                    },
                    -- folds
                    {
                        text = { builtin.foldfunc },
                        click = "v:lua.ScFa"
                    },
                    -- git signs
                    {
                        sign = { namespace = { "gitsigns" } },
                        click = "v:lua.ScSa"
                    }
                }
            })
        end
    }
}
